<?xml version="1.0" encoding="utf-8"?>
<databaseChangeLog
    xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
    xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.9.xsd
                        http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd">

        <property name="autoIncrement" value="true"/>

    <changeSet id="00000000000001" author="zarko">
        <createTable tableName="user">
            <column name="id" type="bigint" autoIncrement="${autoIncrement}" >
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="login" type="varchar(50)">
                <constraints unique="true" nullable="false" uniqueConstraintName="ux_user_login"/>
            </column>
            <column name="password_hash" type="varchar(60)"/>
            <column name="first_name" type="varchar(50)"/>
            <column name="last_name" type="varchar(50)"/>
            <column name="email" type="varchar(191)">
                <constraints unique="true" nullable="true" uniqueConstraintName="ux_user_email"/>
            </column>
<!--            <column name="image_url" type="varchar(256)"/>-->
            <column name="activated" type="boolean" valueBoolean="false">
                <constraints nullable="false" />
            </column>
<!--            <column name="lang_key" type="varchar(10)"/>-->
<!--            <column name="activation_key" type="varchar(20)"/>-->
<!--            <column name="reset_key" type="varchar(20)"/>-->
<!--            <column name="created_by" type="varchar(50)">-->
<!--                <constraints nullable="false"/>-->
<!--            </column>-->
            <column name="created_date" type="timestamp"/>
<!--            <column name="reset_date" type="timestamp">-->
<!--                <constraints nullable="true"/>-->
<!--            </column>-->
<!--            <column name="last_modified_by" type="varchar(50)"/>-->
<!--            <column name="last_modified_date" type="timestamp"/>-->
        </createTable>

        <createTable tableName="authority">
            <column name="name" type="varchar(50)">
                <constraints primaryKey="true" nullable="false"/>
            </column>
        </createTable>

        <createTable tableName="user_authority">
            <column name="user_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="authority_name" type="varchar(50)">
                <constraints nullable="false"/>
            </column>
        </createTable>

        <addPrimaryKey columnNames="user_id, authority_name" tableName="user_authority"/>

        <addForeignKeyConstraint baseColumnNames="authority_name"
                                 baseTableName="user_authority"
                                 constraintName="fk_authority_name"
                                 referencedColumnNames="name"
                                 referencedTableName="authority"/>

        <addForeignKeyConstraint baseColumnNames="user_id"
                                 baseTableName="user_authority"
                                 constraintName="fk_user_id"
                                 referencedColumnNames="id"
                                 referencedTableName="user"/>

        <addNotNullConstraint   columnName="password_hash"
                                columnDataType="varchar(60)"
                                tableName="user"/>
        <loadData
                  file="liquibase/data/user.csv"
                  separator=";"
                  tableName="user">
            <column name="activated" type="boolean"/>
<!--            <column name="created_date" type="timestamp"/>-->
        </loadData>
<!--        <dropDefaultValue tableName="user" columnName="created_date" columnDataType="datetime"/>-->
        <loadData
                  file="liquibase/data/authority.csv"
                  separator=";"
                  tableName="authority">
            <column name="name" type="string"/>
        </loadData>

        <loadData
                  file="liquibase/data/user_authority.csv"
                  separator=";"
                  tableName="user_authority">
            <column name="user_id" type="numeric"/>
        </loadData>
    </changeSet>

</databaseChangeLog>
